"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bind = bind;
var _schema = /*#__PURE__*/require("@traversable/schema");
var JsonSchema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./jsonSchema.js"));
var prototypes = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./prototypes.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/////////////////
///  INSTALL  ///
void bind(); ///
///  INSTALL  ///
/////////////////
function bind() {
  /** @internal */
  let Object_assign = globalThis.Object.assign;
  /** no JSON schema representation */
  Object_assign(_schema.t.never, {
    toJsonSchema: JsonSchema.empty
  });
  Object_assign(_schema.t.void, {
    toJsonSchema: JsonSchema.empty
  });
  Object_assign(_schema.t.undefined, {
    toJsonSchema: JsonSchema.empty
  });
  Object_assign(_schema.t.symbol, {
    toJsonSchema: JsonSchema.empty
  });
  Object_assign(_schema.t.bigint, {
    toJsonSchema: JsonSchema.empty
  });
  /** nullary */
  Object_assign(_schema.t.unknown, {
    toJsonSchema: prototypes.unknown
  });
  Object_assign(_schema.t.any, {
    toJsonSchema: prototypes.any
  });
  Object_assign(_schema.t.null, {
    toJsonSchema: prototypes.null
  });
  Object_assign(_schema.t.boolean, {
    toJsonSchema: prototypes.boolean
  });
  Object_assign(_schema.t.integer, {
    toJsonSchema: prototypes.integer
  });
  Object_assign(_schema.t.number, {
    toJsonSchema: prototypes.number
  });
  Object_assign(_schema.t.string, {
    toJsonSchema: prototypes.string
  });
  /** unary */
  Object_assign(_schema.t.eq.prototype, {
    toJsonSchema: prototypes.eq
  });
  Object_assign(_schema.t.optional.prototype, {
    toJsonSchema: prototypes.optional
  });
  Object_assign(_schema.t.array.prototype, {
    toJsonSchema: prototypes.array
  });
  Object_assign(_schema.t.record.prototype, {
    toJsonSchema: prototypes.record
  });
  Object_assign(_schema.t.union.prototype, {
    toJsonSchema: prototypes.union
  });
  Object_assign(_schema.t.intersect.prototype, {
    toJsonSchema: prototypes.intersect
  });
  Object_assign(_schema.t.tuple.prototype, {
    toJsonSchema: prototypes.tuple
  });
  Object_assign(_schema.t.object.prototype, {
    toJsonSchema: prototypes.object
  });
}
//# sourceMappingURL=install.js.map