"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Functor", {
  enumerable: true,
  get: function () {
    return _functor.Functor;
  }
});
Object.defineProperty(exports, "RAW", {
  enumerable: true,
  get: function () {
    return Spec.RAW;
  }
});
exports.array = array;
exports.boolean = exports.bigint = void 0;
exports.empty = empty;
exports.eq = eq;
Object.defineProperty(exports, "fold", {
  enumerable: true,
  get: function () {
    return _functor.fold;
  }
});
exports.inline = inline;
exports.integer = integer;
exports.intersect = intersect;
Object.defineProperty(exports, "is", {
  enumerable: true,
  get: function () {
    return Spec.is;
  }
});
Object.defineProperty(exports, "isRequired", {
  enumerable: true,
  get: function () {
    return _properties.isRequired;
  }
});
Object.defineProperty(exports, "minItems", {
  enumerable: true,
  get: function () {
    return _items.minItems;
  }
});
exports.never = void 0;
exports.number = number_;
exports.object = object_;
exports.optional = optional;
exports.optionalProto = optionalProto;
Object.defineProperty(exports, "property", {
  enumerable: true,
  get: function () {
    return _properties.property;
  }
});
exports.record = record;
exports.string = string_;
exports.symbol = void 0;
exports.tuple = tuple;
exports.undefined = void 0;
Object.defineProperty(exports, "unfold", {
  enumerable: true,
  get: function () {
    return _functor.unfold;
  }
});
exports.union = union;
exports.void = void 0;
Object.defineProperty(exports, "wrapOptional", {
  enumerable: true,
  get: function () {
    return _properties.wrapOptional;
  }
});
var _registry = /*#__PURE__*/require("@traversable/registry");
var _items = /*#__PURE__*/require("./items.js");
var _properties = /*#__PURE__*/require("./properties.js");
var Spec = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./specification.js"));
var _schema = /*#__PURE__*/require("@traversable/schema");
var _functor = /*#__PURE__*/require("./functor.js");
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
/** @internal */
const Object_keys = globalThis.Object.keys;
/** @internal */
const isNumber = u => typeof u === 'number';
const getNumericBounds = u => ({
  ...((0, _registry.has)('minimum', _schema.t.number)(u) && {
    minimum: u.minimum
  }),
  ...((0, _registry.has)('maximum', _schema.t.number)(u) && {
    maximum: u.maximum
  }),
  ...((0, _registry.has)('exclusiveMinimum', _schema.t.number)(u) && {
    exclusiveMinimum: u.exclusiveMinimum
  }),
  ...((0, _registry.has)('exclusiveMaximum', _schema.t.number)(u) && {
    exclusiveMaximum: u.exclusiveMaximum
  })
});
function applyTupleOptionality(xs, {
  min,
  max
}) {
  return min === max ? xs.map(_properties.getSchema) : [...xs.slice(0, min).map(_properties.getSchema), ...xs.slice(min).map(_properties.getSchema)];
}
/* * * * * * * * * * * * * * * * * * *
 *                                   *
 *   no JSON Schema representation   *
 *                                   *
 * * * * * * * * * * * * * * * * * * */

function empty() {
  return void 0;
}
const Empty = exports.bigint = exports.undefined = exports.symbol = exports.void = exports.never = {
  toJsonSchema: empty
};
function inline(_) {
  return Empty;
}
const boolean_ = () => Spec.RAW.boolean;
exports.boolean = boolean_;
function integer(schema) {
  const {
    exclusiveMaximum,
    exclusiveMinimum,
    maximum,
    minimum
  } = getNumericBounds(schema);
  let bounds = {};
  if (typeof exclusiveMinimum === 'number') bounds.exclusiveMinimum = exclusiveMinimum;
  if (typeof exclusiveMaximum === 'number') bounds.exclusiveMaximum = exclusiveMaximum;
  if (typeof minimum === 'number') bounds.minimum = minimum;
  if (typeof maximum === 'number') bounds.maximum = maximum;
  return {
    ...Spec.RAW.integer,
    ...bounds
  };
}
function number_(schema) {
  const {
    exclusiveMaximum,
    exclusiveMinimum,
    maximum,
    minimum
  } = getNumericBounds(schema);
  let bounds = {};
  if (typeof exclusiveMinimum === 'number') bounds.exclusiveMinimum = exclusiveMinimum;
  if (typeof exclusiveMaximum === 'number') bounds.exclusiveMaximum = exclusiveMaximum;
  if (typeof minimum === 'number') bounds.minimum = minimum;
  if (typeof maximum === 'number') bounds.maximum = maximum;
  return {
    ...Spec.RAW.number,
    ...bounds
  };
}
function string_(schema) {
  const minLength = (0, _registry.has)('minLength', isNumber)(schema) ? schema.minLength : null;
  const maxLength = (0, _registry.has)('maxLength', isNumber)(schema) ? schema.maxLength : null;
  let out = {
    ...Spec.RAW.string
  };
  minLength && void (out.minLength = minLength);
  maxLength && void (out.maxLength = maxLength);
  return out;
}
function eq(value) {
  return {
    const: value
  };
}
function optional(x) {
  function toJsonSchema() {
    return (0, _properties.getSchema)(x);
  }
  toJsonSchema[_registry.symbol.optional] = (0, _properties.wrapOptional)(x);
  return {
    toJsonSchema
  };
}
function optionalProto(child) {
  optionalProto[_registry.symbol.optional] = (0, _properties.wrapOptional)(child);
  return {
    ...(0, _properties.getSchema)(child),
    nullable: true
  };
}
//
function array(child, {
  minLength,
  maxLength
} = {}) {
  return {
    type: 'array',
    items: (0, _properties.getSchema)(child),
    ...(typeof minLength === 'number' && {
      minLength
    }),
    ...(typeof maxLength === 'number' && {
      maxLength
    })
  };
}
function record(child) {
  return {
    type: 'object',
    additionalProperties: (0, _properties.getSchema)(child)
  };
}
function union(children) {
  return {
    anyOf: children.map(_properties.getSchema)
  };
}
function intersect(children) {
  return {
    allOf: children.map(_properties.getSchema)
  };
}
function tuple(children) {
  const min = (0, _items.minItems)(children);
  const max = children.length;
  return {
    type: 'array',
    additionalItems: false,
    items: applyTupleOptionality(children, {
      min,
      max
    }),
    minItems: min,
    maxItems: max
  };
}
function object_(children) {
  const required = Object_keys(children).filter((0, _properties.isRequired)(children));
  return {
    type: 'object',
    required,
    properties: _registry.fn.map(children, (v, k) => (0, _properties.property)(required)(v, k))
  };
}
//# sourceMappingURL=jsonSchema.js.map