"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.any = toJsonSchemaAny;
exports.array = toJsonSchemaArray;
exports.boolean = toJsonSchemaBoolean;
exports.eq = toJsonSchemaEq;
exports.integer = toJsonSchemaInteger;
exports.intersect = toJsonSchemaIntersect;
exports.null = toJsonSchemaNull;
exports.number = toJsonSchemaNumber;
exports.object = toJsonSchemaObject;
exports.optional = toJsonSchemaOptional;
exports.record = toJsonSchemaRecord;
exports.string = toJsonSchemaString;
exports.tuple = toJsonSchemaTuple;
exports.union = toJsonSchemaUnion;
exports.unknown = toJsonSchemaUnknown;
var Spec = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./specification.js"));
var JsonSchema = /*#__PURE__*/_interopRequireWildcard(/*#__PURE__*/require("./jsonSchema.js"));
function _getRequireWildcardCache(e) {
  if ("function" != typeof WeakMap) return null;
  var r = new WeakMap(),
    t = new WeakMap();
  return (_getRequireWildcardCache = function (e) {
    return e ? t : r;
  })(e);
}
function _interopRequireWildcard(e, r) {
  if (!r && e && e.__esModule) return e;
  if (null === e || "object" != typeof e && "function" != typeof e) return {
    default: e
  };
  var t = _getRequireWildcardCache(r);
  if (t && t.has(e)) return t.get(e);
  var n = {
      __proto__: null
    },
    a = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) {
    var i = a ? Object.getOwnPropertyDescriptor(e, u) : null;
    i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u];
  }
  return n.default = e, t && t.set(e, n), n;
}
function toJsonSchemaAny() {
  return Spec.RAW.any;
}
function toJsonSchemaUnknown() {
  return Spec.RAW.any;
}
function toJsonSchemaNull() {
  return Spec.RAW.null;
}
function toJsonSchemaBoolean() {
  return JsonSchema.boolean();
}
function toJsonSchemaInteger() {
  return JsonSchema.integer(this);
}
function toJsonSchemaNumber() {
  return JsonSchema.number(this);
}
function toJsonSchemaString() {
  return JsonSchema.string(this);
}
function toJsonSchemaEq() {
  return JsonSchema.eq(this.def);
}
function toJsonSchemaOptional() {
  return JsonSchema.optionalProto(this.def);
}
function toJsonSchemaRecord() {
  return JsonSchema.record(this.def);
}
function toJsonSchemaUnion() {
  return JsonSchema.union(this.def);
}
function toJsonSchemaIntersect() {
  return JsonSchema.intersect(this.def);
}
function toJsonSchemaTuple() {
  return JsonSchema.tuple(this.def);
}
function toJsonSchemaObject() {
  return JsonSchema.object(this.def);
}
function toJsonSchemaArray() {
  return JsonSchema.array(this.def, {
    minLength: this.minLength,
    maxLength: this.maxLength
  });
}
//# sourceMappingURL=prototypes.js.map