import { t } from '@traversable/schema';
import * as JsonSchema from './jsonSchema.js';
import { symbol as Sym } from '@traversable/registry';
export { toJsonSchemaAny as any, toJsonSchemaUnknown as unknown, toJsonSchemaNull as null, toJsonSchemaBoolean as boolean, toJsonSchemaInteger as integer, toJsonSchemaNumber as number, toJsonSchemaString as string, toJsonSchemaEq as eq, toJsonSchemaArray as array, toJsonSchemaOptional as optional, toJsonSchemaRecord as record, toJsonSchemaUnion as union, toJsonSchemaIntersect as intersect, toJsonSchemaTuple as tuple, toJsonSchemaObject as object, };
declare function toJsonSchemaAny(this: t.any): {
    type: "object";
    properties: {};
    nullable: true;
};
declare function toJsonSchemaUnknown(this: t.unknown): {
    type: "object";
    properties: {};
    nullable: true;
};
declare function toJsonSchemaNull(this: t.null): {
    type: "null";
    enum: [null];
};
declare function toJsonSchemaBoolean(this: t.boolean): {
    type: "boolean";
};
declare function toJsonSchemaInteger(this: t.integer): {
    minimum?: number | undefined;
    maximum?: number | undefined;
    exclusiveMinimum?: number | boolean | undefined;
    exclusiveMaximum?: number | boolean | undefined;
    type: "integer";
};
declare function toJsonSchemaNumber(this: t.number): {
    minimum?: number | undefined;
    maximum?: number | undefined;
    exclusiveMinimum?: number | boolean | undefined;
    exclusiveMaximum?: number | boolean | undefined;
    type: "number";
};
declare function toJsonSchemaString(this: t.string): never;
declare function toJsonSchemaEq<V>(this: t.eq<V>): {
    const: V;
};
declare function toJsonSchemaOptional<S extends t.Schema>(this: t.optional<S>): any;
declare function toJsonSchemaRecord<S extends t.Schema>(this: t.record<S>): {
    type: "object";
    additionalProperties: S;
};
declare function toJsonSchemaUnion<S extends t.Schema[]>(this: t.union<S>): {
    anyOf: any[];
};
declare function toJsonSchemaIntersect<S extends readonly t.Schema[]>(this: t.intersect<S>): {
    allOf: any[];
};
declare function toJsonSchemaTuple<S extends readonly t.Schema[]>(this: t.tuple<S>): {
    type: "array";
    additionalItems: false;
    items: never;
    minItems: never;
    maxItems: number;
};
declare function toJsonSchemaObject<S extends {
    [x: string]: t.Schema;
}>(this: t.object<S>): {
    type: "object";
    required: JsonSchema.RequiredKeys<S, keyof S, keyof S extends infer T_2 ? T_2 extends keyof S ? T_2 extends T_2 ? S[T_2]["toJsonSchema" & keyof S[T_2]] extends {
        [symbol_optional]: number;
    } ? never : T_2 : never : never : never> extends infer T extends JsonSchema.RequiredKeys<T_3, keyof T_3, keyof T_3 extends infer T_4 ? T_4 extends keyof T_3 ? T_4 extends T_4 ? T_3[T_4]["toJsonSchema" & keyof T_3[T_4]] extends {
        [symbol_optional]: number;
    } ? never : T_4 : never : never : never> ? { [I in keyof T]: JsonSchema.RequiredKeys<S, keyof S, keyof S extends infer T_1 ? T_1 extends keyof S ? T_1 extends T_1 ? S[T_1]["toJsonSchema" & keyof S[T_1]] extends {
        [symbol_optional]: number;
    } ? never : T_1 : never : never : never>[I] & string; } : never;
    properties: { [K in keyof S]: import("@traversable/schema").Returns<S[K]["toJsonSchema" & keyof S[K]]>; };
};
declare function toJsonSchemaArray<S extends t.Schema>(this: t.array<S>): {
    type: "array";
    items: import("@traversable/schema").Returns<S["toJsonSchema" & keyof S]>;
    minLength: number;
    maxLength: number;
};
//# sourceMappingURL=prototypes.d.ts.map