import * as Spec from './specification.js';
import * as JsonSchema from './jsonSchema.js';
export { toJsonSchemaAny as any, toJsonSchemaUnknown as unknown, toJsonSchemaNull as null, toJsonSchemaBoolean as boolean, toJsonSchemaInteger as integer, toJsonSchemaNumber as number, toJsonSchemaString as string, toJsonSchemaEq as eq, toJsonSchemaArray as array, toJsonSchemaOptional as optional, toJsonSchemaRecord as record, toJsonSchemaUnion as union, toJsonSchemaIntersect as intersect, toJsonSchemaTuple as tuple, toJsonSchemaObject as object };
function toJsonSchemaAny() {
  return Spec.RAW.any;
}
function toJsonSchemaUnknown() {
  return Spec.RAW.any;
}
function toJsonSchemaNull() {
  return Spec.RAW.null;
}
function toJsonSchemaBoolean() {
  return JsonSchema.boolean();
}
function toJsonSchemaInteger() {
  return JsonSchema.integer(this);
}
function toJsonSchemaNumber() {
  return JsonSchema.number(this);
}
function toJsonSchemaString() {
  return JsonSchema.string(this);
}
function toJsonSchemaEq() {
  return JsonSchema.eq(this.def);
}
function toJsonSchemaOptional() {
  return JsonSchema.optionalProto(this.def);
}
function toJsonSchemaRecord() {
  return JsonSchema.record(this.def);
}
function toJsonSchemaUnion() {
  return JsonSchema.union(this.def);
}
function toJsonSchemaIntersect() {
  return JsonSchema.intersect(this.def);
}
function toJsonSchemaTuple() {
  return JsonSchema.tuple(this.def);
}
function toJsonSchemaObject() {
  return JsonSchema.object(this.def);
}
function toJsonSchemaArray() {
  return JsonSchema.array(this.def, {
    minLength: this.minLength,
    maxLength: this.maxLength
  });
}
//# sourceMappingURL=prototypes.js.map